/*
ID:   cs_diab1
TASK: 
LANG: C++
*/

#include <map>
#include <set>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <cctype>
#include <cstdio>
#include <limits>
#include <string>
#include <vector>
#include <cassert>
#include <climits>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <iomanip>
#include <numeric>
#include <sstream>
#include <utility>
#include <iostream>
#include <algorithm>
#include <functional>
#include <conio.h>

#define stop exit(0)
#define nc -1
#define eps 1e-10
#define inf 1000000000
#define mod 1000000007
#define mp make_pair

#define fill(array,value) memset(array,value,sizeof(array))
#define f(i,beg,end) for(int i=beg; i<=end; i++)
#define F(i,beg,end) for(int i=beg; i>=end; i--)
#define Max(a,b) ( (a>b)?a:b )
#define Min(a,b) ( (a<b)?a:b )
#define pi 3.1415926535897932384626433832
#define iread(var) scanf("%d",&var)
#define dread(var) scanf("%f",&var)
#define lread(var) scanf("%lld",&var)
#define input(name) freopen(name,"r",stdin)
#define output(name) freopen(name,"w",stdout)
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;
typedef long long ll;

using namespace std;
struct animals
{
    int r, c, k, t;
    char shape[14][14];
    
    void read() 
    {
        cin>>r>>c>>k>>t;
        f(i,1,r)
            f(j,1,c)
                cin>>shape[i][j];
    }
    void print()
    {
        cout<<r<<" "<<c<<" "<<k<<" "<<t<<endl;
        f(i,1,r)
        {
            f(j,1,c) 
                cout<<shape[i][j];
            cout<<endl;
        }
    }
};

vector <int> Ind, Row, Col;

struct board
{
    int jumped[51], Count;
    animals animal[101];
    int rows, cols, safety[51][51], allSafety, cantMakeMove;
    int jump[101][51][51];      // jump [ animalIndex, row, col ] = 
    
    board () { allSafety=0; fill(jumped,0); Count=rows=cols=0; fill(jump,0); cantMakeMove=0; }
    
    void read()
    {
        cin>>rows>>cols>>Count;
        f(i,1,rows)
            f(j,1,cols)
                cin>>safety[i][j];
        f(i,1,Count)
            animal[i].read();
    }
    
    void print()
    {
        cout<<rows<<" "<<cols<<" "<<Count<<endl;
        f(i,1,rows)
        {
            f(j,1,cols)
                cout<<safety[i][j]<<" ";
            cout<<endl;
        }
        f(i,1,Count)
        {
            cout<<"Animal "<<i<<" : ";
            animal[i].print();
        }
    }
    int findSafety(int row, int col, int animalIndex)
    {
        int ret=0, ok=1, r2, c2, r1, c1, maxr=animal[animalIndex].r, maxc=animal[animalIndex].c, mint=animal[animalIndex].t;
        //cout<<"ANIMAL INDEX "<<animalIndex<<" "<<row<<" "<<col<<endl;
        if (row+maxr-1>rows || col+maxc-1>cols) return 0;
        
        for(r1=row, r2=1; r2<=maxr; r1++, r2++)
            for(c1=col, c2=1; c2<=maxc; c1++, c2++)
                if (animal[animalIndex].shape[r2][c2]=='1')
                {
                    ret+=safety[r1][c1];
                    //cout<<"ret "<<ret<<" "<<r1<<" "<<c1<<" animal "<<r2<<" "<<c2<<" "<<maxr<<" "<<maxc<<endl;
                    if (safety[r1][c1]<mint) ok=-1;
                }
        //cout<<"SAFETY "<<row<<" "<<col<<endl; animal[animalIndex].print(); cout<<ret*ok<<endl;
        //getch();
        return ret*ok;      // negative, if the jump is "dangerous"
    }
    void findJumps()
    {
        f(i,1,Count)
            f(j,1,rows)
                f(k,1,cols)
                    jump[i][j][k]=findSafety(j,k,i);
    }
    // criteria for best jump
    int comp(int ind1, int r1, int c1, int ind2, int r2, int c2)
    {
        return (jump[ind1][r1][c1]>jump[ind2][r2][c2]);   // return bigger safety
    }
    void findBestJump(int &animalindex, int &red, int &colona)
    {
        findJumps();
        int sol=0;
        f(i,1,Count)
            if (!jumped[i])
            f(j,1,rows)
                f(k,1,cols) //{ //printf(" dp[ %d ][ %d ][ %d ]=%d\n",i,j,k,jump[i][j][k]);
                    if (jump[i][j][k]>0)
                    {
                        //cout<<" I J K "<<i<<" "<<j<<" "<<k<<endl;
                        if (!sol) { sol=1; animalindex=i; red=j; colona=k; }
                        else if (comp(i,j,k,animalindex,red,colona)) { animalindex=i; red=j; colona=k; }
                    } //}
        //cout<<" SOL "<<sol<<" "<<animalindex<<" "<<red<<" "<<colona<<endl;
        if (!sol || jump[animalindex][red][colona]<=0) cantMakeMove=1;
    }
    void makeJump(int animalIndex, int row, int col)
    {
        int r1, r2, c1, c2, maxr=animal[animalIndex].r, maxc=animal[animalIndex].c, koef=animal[animalIndex].k;
        jumped[animalIndex]=1;
        
        for(r1=row, r2=1; r2<=maxr; r1++, r2++)
            for(c1=col, c2=1; c2<=maxc; c1++, c2++)
                if (animal[animalIndex].shape[r2][c2]=='1')
                {
                    allSafety+=safety[r1][c1];
                    safety[r1][c1]/=koef;
                }
        Ind.push_back(animalIndex);
        Row.push_back(row);
        Col.push_back(col);
    }
    void makeMove()
    {
        int a, b, c;
        findBestJump(a,b,c);
        
        if (cantMakeMove) return; 
        //cout<<"Making move: animal no. "<<a<<" row "<<b<<" col "<<c<<" SAFETY "<<jump[a][b][c]<<endl;
        makeJump(a,b,c);
    }
    
} startingState;

void init()
{
    startingState.read();
    //startingState.print();
    
    //cout<<endl<<endl<<endl;
    
    //startingState.makeMove();
    //startingState.print();
}

void solve()
{
    while (!startingState.cantMakeMove)
        startingState.makeMove();
    //cout<<startingState.allSafety<<endl;
    
    int n=Ind.size();
    cout<<n<<endl;
    f(i,0,n-1)
    {
        cout<<Ind[i]<<" "<<Row[i]<<" "<<Col[i]<<endl;
    }
    //startingState.print();
}

int main()
{
    //input("test2.txt");
    input("parash.in");
    output("parash.out");
    init();
    solve();

    return 0;
}